/* SLPv2 model for Omnet++
 * Copyright (C) 2004  Manuel Urueña <muruenya@it.uc3m.es>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#ifndef SERVICEAGENT_H_
#define SERVICEAGENT_H_

#include "UserAgent.h"
#include "api_m.h"
#include "slpv2_m.h"
#include "Service.h"

class ServiceAgent : public UserAgent
{
  Module_Class_Members ( ServiceAgent, UserAgent, 0 )

  Service* agentService;

     cArray serviceCache;

  simtime_t occupiedUntil;
  cOutVector slpQueueLength;

  virtual void initialize();
  virtual void handleMessage(cMessage *msg);

  virtual void handleSLPReg(SLPReg *slp_reg);

  virtual void handleServiceAcknowledgement
  ( ServiceAcknowledgement* srv_ack, Sockaddr_in* saddr );

  virtual void handleServiceRequest
  ( ServiceRequest* srv_rqst, Sockaddr_in* saddr );

  virtual SLPv2Message* createAdvertisementReply
  ( ServiceRequest* srv_rqst );

  virtual void handleServiceTypeRequest
  ( ServiceTypeRequest* srv_type_rqst, Sockaddr_in* saddr );

  virtual void handleAttributeRequest
  ( AttributeRequest* attr_rqst, Sockaddr_in* saddr );

  virtual void handleFatalTimeout ( SLPv2Message* slpv2 );

  virtual void sendReply ( SLPv2Message* msg );
};

#endif
