/* SLPv2 model for Omnet++
 * Copyright (C) 2004  Manuel Urueña <muruenya@it.uc3m.es>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#ifndef SOCKADDR_IN_H_
#define SOCKADDR_IN_H_

#include <omnetpp.h>
#include <string>
using std::string;

class Sockaddr_in : public cObject
{
 protected:
  string sin_port;
  string sin_addr;
   
 public:
  Sockaddr_in(const char* name, const char* port, const char* addr);
  const char* getPort();
  const char* getAddress();

  //cObject stuff
  Sockaddr_in(const char* name=NULL);
  Sockaddr_in(const Sockaddr_in& other);
  virtual ~Sockaddr_in();
  virtual cObject *dup() const;
  Sockaddr_in& operator=(const Sockaddr_in& other);
  virtual void foreach(ForeachFunc f);
  virtual void info (char * buf);
  virtual void writeContents(std::ostream& os);
};

#endif
