/* SLPv2 model for Omnet++
 * Copyright (C) 2004  Manuel Urueña <muruenya@it.uc3m.es>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#ifndef USERAGENT_H_
#define USERAGENT_H_

#include "api_m.h"
#include "slpv2_m.h"
#include "Sockaddr_in.h"

class UserAgent : public cSimpleModule
{
 public:
  Module_Class_Members(UserAgent, cSimpleModule, 0)

  const char* useScopes;
  const char* DAAddresses;
  const char* locale;
    simtime_t multicastMaximumWait;
    simtime_t multicastTimeout;
    simtime_t DADiscoveryTimeout;
    simtime_t datagramTimeout;
    simtime_t randomWaitBound;
          int MTU;

        int xid;
     cQueue timers;
  SLPHandle slpHandle;
  
  virtual void initialize();
  virtual void handleMessage (cMessage * msg);

  virtual void handleSLPFindSrvs
  (SLPFindSrvs * slp_find_srvs);

  virtual void handleSLPFindSrvsTypes
  (SLPFindSrvsTypes * slp_find_srvs_types);

  virtual void handleSLPFindAttrs
  (SLPFindAttrs * slp_find_attrs);


  virtual void handleServiceReply
  (ServiceReply * srv_rply, Sockaddr_in* saddr);

  virtual void handleServiceTypeReply
  (ServiceTypeReply * srv_type_rply, Sockaddr_in* saddr);

  virtual void handleAttributeReply
  (AttributeReply * attr_rply, Sockaddr_in* saddr);
  
  virtual void handleDAAdvertisement
  (DAAdvertisement* da_advert, Sockaddr_in* saddr);

  virtual void handleSAAdvertisement
  (SAAdvertisement* sa_advert, Sockaddr_in* saddr);

  virtual void handleActiveDADiscovery(ServiceRequest* srv_rqst);

  virtual void scheduleTimer(SLPv2Message* msg, simtime_t timeout);
  virtual void cancelTimer(int xid);

  virtual void handleTimeout(cMessage * msg);
  virtual void handleFatalTimeout(SLPv2Message* slpv2);

  virtual void handleMulticastDiscoveryTimeout(cMessage* msg);
};

#endif
