/* SLPv2 model for Omnet++
 * Copyright (C) 2004  Manuel Urueña <muruenya@it.uc3m.es>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#ifndef DEBUG_H_
#define DEBUG_H_

#include "api_m.h"
#include "slpv2_m.h"
#include "client_server_m.h"
#include "Sockaddr_in.h"

void debug ( simtime_t time, const char* host, const char* app, 
	     char type );
void debug ( char type );

void debug ( SLPFindSrvs* slp_find_srvs );

void debug ( SLPSrvURLAttrsCallback* callback );

void debug ( SLPSrvURLCallback* callback );

void debug ( SLPFindAttrs* slp_find_attrs );

void debug ( SLPAttrCallback* callback );

void debug ( SLPFindSrvsTypes* slp_find_srvs_types );

void debug ( SLPSrvTypeCallback * callback );

void debug ( SLPv2Message* slp, Sockaddr_in* saddr=NULL );

void debug ( ServiceRequest* srv_rqst, Sockaddr_in* saddr=NULL );
void debug ( ServiceReply* srv_rply, Sockaddr_in* saddr=NULL );

void debug ( ServiceRegistration* srv_reg, Sockaddr_in* saddr=NULL );
void debug ( ServiceAcknowledgement* srv_ack, Sockaddr_in* saddr=NULL );

void debug ( DAAdvertisement* da_advert, Sockaddr_in* saddr=NULL );
void debug ( SAAdvertisement* sa_advert, Sockaddr_in* saddr=NULL );

void debug ( ServiceTypeRequest* srv_type_rqst, Sockaddr_in* saddr=NULL );
void debug ( ServiceTypeReply* srv_type_rply, Sockaddr_in* saddr=NULL );

void debug ( AttributeRequest* attr_rqst, Sockaddr_in* saddr=NULL );
void debug ( AttributeReply* attr_rply, Sockaddr_in* saddr=NULL );

void debug ( ServiceDeregistration* srv_dereg, Sockaddr_in* saddr=NULL );

void debug ( ClientRequest* clnt_rqst, Sockaddr_in* saddr=NULL );
void debug ( ServerResponse* srv_rsp, Sockaddr_in* saddr=NULL );

#endif
