/* SLPv2 model for Omnet++
 * Copyright (C) 2004  Manuel Urueña <muruenya@it.uc3m.es>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include <stdlib.h>
#include <string.h>

#include "util.h"

char* expandVar ( const char* str, 
		  const char* var, const char* val )
{
  char * var_ptr = strstr(str, var);
  if (var_ptr == NULL) {
    return strdup(str);
  }

  int str_len = strlen(str);
  int var_len = strlen(var);
  int val_len = strlen(val);
  int aux_len = str_len + val_len - var_len;
  char * aux = (char*) malloc(aux_len+1);

  int prefix_len = (int) (var_ptr - str);
  strncpy(aux, str, prefix_len);
  strcpy(aux+prefix_len, val);

  char * suffix_ptr = var_ptr + var_len;
  strcat(aux, suffix_ptr);

  return aux;
}

char* url2addr ( const char* url )
{
  char * begin_ptr = strstr(url, "://") + 3;
  int url_len = strlen(url);
  int prefix_len = (int) (begin_ptr - url);
  int addr_len = url_len - prefix_len;

  char * end_ptr = strchr(begin_ptr, '/');
  if (end_ptr != NULL) {
    addr_len = end_ptr - begin_ptr;
  }
  char * addr = (char*) malloc(addr_len+1);
  strncpy(addr, begin_ptr, addr_len);
  addr[addr_len] = '\0';

  return addr;
}
